// Generated by CoffeeScript 1.3.3
(function() {
  var Entity;

  Artemis.Entity = {};

  Entity = (function() {

    function Entity(world, id) {
      this.world = world;
      this.id = id;
      this.typeBits = 0;
      this.systemBits = 0;
    }

    Entity.prototype["delete"] = function() {
      return this.world.deleteEntity(this);
    };

    Entity.prototype.addComponent = function(component) {
      if (!(component instanceof Artemis.Component)) {
        throw new Error("Tried to add a component that is not inheriting from Component");
      }
      this.world.entityManager._addComponent(this, component);
      return null;
    };

    Entity.prototype.removeComponent = function(componentName) {
      this.world.entityManager._removeComponent(this, componentName);
      return null;
    };

    Entity.prototype.getComponent = function(componentName) {
      return this.world.entityManager._getComponent(this, componentName);
    };

    Entity.prototype.refresh = function() {
      return this.world.refreshEntity(this);
    };

    Entity.prototype._addTypeBit = function(bit) {
      return this.typeBits |= bit;
    };

    Entity.prototype._removeTypeBit = function(bit) {
      return this.typeBits &= ~bit;
    };

    Entity.prototype._addSystemBit = function(bit) {
      return this.systemBits |= bit;
    };

    Entity.prototype._removeSystemBit = function(bit) {
      return this.systemBits &= ~bit;
    };

    Entity.prototype.isActive = function() {
      return this.world.entityManager._isActive(this.id);
    };

    Entity.prototype.setGroup = function(group) {
      return this.world.groupManager.set(group, this);
    };

    Entity.prototype.setTag = function(tag) {
      return this.world.tagManager.register(tag, this);
    };

    Entity.prototype.getComponents = function() {};

    return Entity;

  })();

  Artemis.Entity = Entity;

}).call(this);
